#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use PureMessage::Manager::Request::Safe ('PureMessage::Manager::Response::Quarantine::Enduser', import => [qw($REQUEST %in %text)] );
use PureMessage::Manager::Safe PureMessage::Resources::Manager;
use PureMessage::Manager::Response::Policy;
use PureMessage::MultiList;
use PureMessage::Version qw($PREFIX);
use PureMessage::Manager::Widget;
use PureMessage::ListManager;
use PureMessage::Manager::Response::Quarantine::Enduser;
use PureMessage::Manager::Lang qw(text);
use HTML::Entities;
use strict;
my %vars;
our %text;

my $WIDGET = new PureMessage::Manager::Widget;


my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Quarantine::Enduser',
                                'stderr_to_stdout' =>1 );

$r->{debug} = 0;
$r->add_help(text => "Help", tab => "quar", page => "mgr_quar_enduser_lists" );
  
sub _info_box {
    my $msg = shift;
    my $ib = $WIDGET->widget(
	CLASS => 'PureMessage::Manager::Widget::InfoBox',
	msg => $msg);
    $ib;
}
my $list_id = $in{'id'};
my $key = $in{add} ? lc $in{new_key} : $in{key};
my $data;
my $is_operation = undef;
my @key_data;
my $rm;
my $temp;

eval {
  $rm = PureMessage::Resources::Manager->new();
  $temp = $rm->find($list_id);
};
if ($@) {
  # database error likely
  warn $@;
  $r->raise_error(<<EOF);
Unable to access list '$list_id'. If this is a resource stored in the 
database then this is likely a misconfiguration of your database.  For 
further details check the manager error log.
EOF
 $r->send();
 exit;
}

my $ml;
if($temp) {
    $ml = $temp->native();
    $data->{name} = $temp->description();
} else {
    $ml = PureMessage::MultiList->new($list_id);
    ($data) = PureMessage::MultiList->Available($list_id) if $list_id;
}

$ml->enumerate_keys(sub { push(@key_data,shift) });
@key_data = sort @key_data;

if ($data and $WIDGET->read_input($REQUEST,'grid_list')) {
    my $wdata = $WIDGET->result_data();
    
    if (exists($wdata->{selected_row}) and defined($wdata->{selected_row}) and $wdata->{'delete'} ) {
        my @selected;
        push(@selected,$wdata->{selected_row}) unless ref($wdata->{selected_row}) eq 'ARRAY';
        @selected = @{$wdata->{selected_row}} if ref($wdata->{selected_row}) eq 'ARRAY';
        $is_operation = 1;
        foreach my $index (@selected) {
          my $key = $key_data[$index]; 
          my $temp = $ml->find_list(writable => 1, key => $key);
          unless ($temp) {
            $r->raise_error("Unable to delete '$key' from '$list_id'");
            next;
          };

          my $ld = $temp->data();
          if ($ld->is_readonly ) {
             $r->raise_error("List is readonly '$list_id'");
             next;
          }
          $ld->clear();
          $ld->delete_source();
          $ld->commit();
        }
        @key_data = ();
        $ml->enumerate_keys(sub { push(@key_data,shift) });
        @key_data = sort @key_data;
    } elsif ($wdata->{'key'}) {
      $key = $wdata->{'key'} unless $key;
    } 
};


if($list_id and $data and $key and not $is_operation) {
	$r->title("Edit List : $data->{name} : ".encode_entities($key,'&<>"\/\''));
    my $new_widget = $r->addmListEditor(
                                       name => 'edit_list',
									   list => encode_entities($list_id),
                                       page => 0,
                                       action => $ENV{SCRIPT_NAME},
                                       key => $key,
									   state => { id => encode_entities($list_id,'&<>"\/\''), key => encode_entities($key,'&<>"\/\'') },
                                      ); 


} elsif( $list_id and $data)  {
  # then we need to show them a list of available keys and let them 
  # choose the right one
   $r->title("Edit List : $data->{name}");
   $r->add_part(_info_box(text('list_is_resource',$rm->store_type())));
   $WIDGET->{name} = 'grid_list';
   my @keys = map { [ button({ type=> 'text', slave=>$WIDGET->make_form_name('key'), name=>'key', value=>encode_entities($_,'&<>"\/\''), text=>encode_entities($_,'&<>"\/\'')})] } @key_data;

   my $tb = $r->ToolBar(buttons=>[
                                [
                                 {type=>'image', icon=>'delete', name=>'delete', text=>'Delete'},
                                 {type=>'image', icon=>'delete', href=>"..", text=>'Cancel'},
                                 {type=>'hidden', name=>'key', value=>''},
                                ]
                                ]);

  my $button = button({type=>'image', name=>'add', value=>'add',icon=>'add', text=>'add', alt=>'Create'});
  my $new_key = <<EOF;
<table> 
  <tr>
   <td width="90%"> <input class=stretch type=text name=new_key value=''> </td>
   <td nowrap> $button </td>
  </tr>
</table>
EOF
  my $new_widget = $r->addGrid ( 
                                name => 'grid_list',
                                paging => 1,
                                page_size=>20,
                                title => 'Available List Keys',
                                columns => 1,
                                selectable => 1,
                                toolbar => $tb,
                                width => 400,
                                state => { id => $list_id },
                                action => $ENV{SCRIPT_NAME},
                                special => [ $new_key ],
                                ddata => [ { 
                                             #width => '50%',
                                             description => 'Key',
                                             extra => 'nowrap',
                                           }
                                         ],
                                data => \@keys,
                               );

} else {
    $r->title('Edit List');
    $r->raise_error('Invalid List Name') unless $list_id;
    $r->error_dlg();
}
            
$r->send();


